from random import random

class Network:
	def __init__(self):
		self.nodes = []
		self.adj = []
		self.nedges = 0
		self.edge_count = dict()

	def __str__(self):
		return str(self.adj)
	
	def add_edge(self, i, j):
		self.adj[i].append(j)
		self.adj[j].append(i)
		self.edge_count[i] += 1
		self.edge_count[j] += 1
		self.nedges += 2

	def add_node(self, u):
		self.nodes.append(u)
		self.adj.append([])
		self.edge_count[len(self.nodes)-1] = 0
	
	def neighbors(self, u):
		u_index = self.nodes.index(u)
		indices = self.adj[u_index]
		neighbors = []
		for i in indices:
			neighbors.append(self.nodes[i])
		return neighbors

	def preferential_attach(self, u, m):
		neighbors = []
		while len(neighbors) < m:
			v = self._find_random()
			if not v in neighbors:
				neighbors.append(v)
		self.add_node(u)
		u_index = len(self.nodes)-1
		for v in neighbors:
			self.add_edge(u_index,v)

	def _find_random(self):
		pr = []
		for i in range(0, len(self.nodes)):
			pr.append(self.edge_count[i]/self.nedges)
		#print(sum(pr))
		# this is an annoying little imprecision:
		# due to floating point arithmetics, our
		# probabilities often do not exactly add up to
		# one, therefore, we just use the last node
		# that thus becomes very slightly to likely
		current_pr = 0
		rand = random()
		for i in range(0, len(self.nodes)):
			current_pr += pr[i]
			if rand < current_pr:
				return i
		print("WARNING: PREFERENTIAL ATTACHMENT: DEFAULTING DUE TO FLOATING POINT IMPRECISION")
		return len(nodes)-1
		
